# FIXME:
# libs/el32/hash.cpp:148: error: cast from 'ELShared*' to 'int' loses precision

# Enable/disable KDE support
%def_enable kde
%def_disable kjs

Name: rekall
Version: 2.4.6
Release: alt2

Summary: Rekall - database front-end

Group: Development/Databases

License: GPL
Url: http://www.rekallrevealed.org/

Packager: Vitaly Lipatov <lav@altlinux.ru>

Source: http://www.rekallrevealed.org/packages/%name-%version.tar.bz2
Patch: rekall-gcc4.patch
Patch1: rekall-%version-fix.patch

Requires: %name-common = %version-%release

%add_python_req_skip Rekall rkWalker

# manually removed: kde-i18n-ru bk glibc-devel-static
# Automatically added by buildreq on Sun May 25 2008
BuildRequires: cppunit-devel cvs flex gcc-c++ ghostscript-utils glibc-devel kdelibs-devel libMySQL-devel libmdbtools-devel libpth-devel libqt3-devel libsqlite3-devel libunixODBC-devel postgresql-devel python-devel python-module-PyXML python-modules-email python-modules-encodings rcs scons swig tetex-latex xml-utils xsltproc

BuildPreReq: rpm-build-compat

%if_enabled kde
BuildRequires: kdelibs-devel
%endif

BuildRequires: libxbsql-devel libxbase-devel

%description
Rekall is a database front-end, somewhat in the style of MicroSoft(R)
Access(TM). However, Rekall is not itself a database, and does not
include a database. By this we mean that data is stored somewhere else
in an SQL server, and Rekall is fundementaly just a tool to extract,
display and update that data (of course, it does lots more than that,
it does forms and reports and scripting and... you get the idea). It
is database agnostic, and does not have any preferred database in the
sense that Access(TM) uses the Jet database engine (although the
Windows version can use the Jet database engine via an ODBC driver).

Rekall can do lots of the things that you would expect of a database
front-end (or if it can't, let us know!). You can design and use forms
and reports, you can construct database queries, and you can import
and export data (actually, you can copy data, import is just copy file
to table, and export is just copy table to file). You can also create
reusable components which you can use in forms and reports, to reduce
application development time.

Rekall can be scripted using the Python language. You can arrange that
a script is executed when various events occur (for instance, when the
user changes the value of a control). Scripts can be associated
directly with the event, but you can also store scripts in script
modules for more general use. And, of course, you have full access to
all the modules that are available for Python. Plus, Rekall has an
integrated Python debugger with syntax highlighting.

%package common
Summary: Common files for full and runtime version of Rekall
Group: System/Libraries

%description common
Common files for full and runtime version of Rekall.

%package driver-mysql
Summary: MySQL database driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-mysql
MySQL database driver for Rekall.

%package driver-sqlite
Summary: SQLite database driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-sqlite
SQLite database driver for Rekall.

%package driver-mdb
Summary: MDB database driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-mdb
MDB database driver for Rekall.

%package driver-odbc
Summary: ODBC database driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-odbc
ODBC database driver for Rekall.

%package driver-pgsql
Summary: PostgreSQL database driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-pgsql
PostgreSQL database driver for Rekall.

%package driver-xbase
Summary: XBase/XBSQL database driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-xbase
XBase/XBSQL database driver for Rekall.

%package driver-dbtcp
Summary: DBTCP driver for Rekall
Group: System/Libraries
Requires: %name-common = %version-%release

%description driver-dbtcp
DBTCP driver for Rekall.

%package devel
Summary: Header files for Rekall libraries
Group: Development/C
Requires: %name-common = %version-%release

%description devel
Header files for Rekall libraries.

%prep
%setup -q
#%patch1

%build
unset QTDIR || : ; . /etc/profile.d/qt3dir.sh
#%__make -f admin/Makefile.common cvs
cp scons/Makefile .

# hack for linking (wait for new scons?)
#LD_RUN_PATH=""
#for i in test/api test/alltests test/common test/kbase test/dummy test/api_script db/dbtcp db/mysql db/pgsql db/xbase support/dbtcp support/xbase support/xbsql libs/common libs/kbase libs/el32 libs/wizard libs/app libs/extra libs/kdeplugins ports/kde ports/rkdcop kbase parts/component parts/copier parts/editor parts/form parts/macro parts/query parts/report parts/table2 plugins/scriptall script/kjs ; do
#	echo "Add rpath-link $i"
#	LD_RUN_PATH="$LD_RUN_PATH:$(pwd)/build/kde/$i"
#done
#export LD_RUN_PATH
#find -name "SConscript*" | xargs %__subst "s|_el32  |_el32|g"

PYTHONPATH=scons/ python ./scons/rkScanner.py	\
		--enable-debug=yes		\
		--quick-docs=yes		\
		--prefix=%prefix		\
		--with-qt-dir=%_qt3dir	\
%if_enabled kde
		--mode=kde \
%else
		--mode=qt \
%endif
		--with-pgsql-includes=%_includedir/pgsql \
		--with-pgsql-libraries=%_libdir \
		--with-python-includes=%python_includedir \
		--with-python-libraries=%_libdir \
		--with-mysql-libraries=%_libdir \
		--with-qt-libraries=%_libdir \
		--with-xbase-libraries=%_libdir \
		--with-xbsql-libraries=%_libdir \
		--with-kde-libraries=%_libdir \
		--with-mdb-libraries=%_libdir \
		--with-odbc-libraries=%_libdir \
		--with-sqlite3-libraries=%_libdir \
		--enable-runtime=yes \
		--rpm=1 \
%if_enabled kjs
		--enable-kjs=yes
%else
		--enable-tests=no
%endif

%make_build

%install
# fix broken rule for ldconfig!
%__subst "s|.*ldconfig.*||g" Makefile scons/Makefile
%__subst "s|\(kdedocdir =\).*|\1 '%buildroot%_docdir/kde/HTML'|g" scons/rkConfig_kde.py
%make_install install.kde DESTDIR=%buildroot

# do not install rekallrt
install -D -m644 kbase/rekall.desktop %buildroot%_desktopdir/rekall.desktop
# remove due binaries in test
rm -rf %buildroot%_datadir/apps/rekall/test/forms/
# hack against .246
cd %buildroot%_libdir
for i in `find ./ -name "*.246"` ; do
	ln -fs $i `basename $i .246`
done
cd -

%find_lang %name --with-kde

%post
%post_ldconfig
%update_menus

%postun 
%postun_ldconfig
%clean_menus

%post common -p /sbin/ldconfig
%postun common -p /sbin/ldconfig

%post driver-mysql -p /sbin/ldconfig
%postun driver-mysql -p /sbin/ldconfig

%post driver-pgsql -p /sbin/ldconfig
%postun driver-pgsql -p /sbin/ldconfig

%post driver-xbase -p /sbin/ldconfig
%postun driver-xbase -p /sbin/ldconfig

%post driver-sqlite -p /sbin/ldconfig
%postun driver-sqlite -p /sbin/ldconfig

%post driver-odbc -p /sbin/ldconfig
%postun driver-odbc -p /sbin/ldconfig

%post driver-dbtcp -p /sbin/ldconfig
%postun driver-dbtcp -p /sbin/ldconfig

%post driver-mdb -p /sbin/ldconfig
%postun driver-mdb -p /sbin/ldconfig


%files
%doc AUTHORS README.FIRST Release.Notes doc/HOWTO
%_bindir/rekall*
# libraries
%_libdir/libkbase.so*
%_libdir/libkbase_app.so*
%_libdir/libkbase_wizard.so*
#%_libdir/librekall.so
# KDE-like modules
%_libdir/libkbase_componentview.so*
%_libdir/libkbase_copierview.so*
%_libdir/libkbase_editor.so*
%_libdir/libkbase_formview.so*
%_libdir/libkbase_macroview.so*
%_libdir/libkbase_plugin_extra.so*
%_libdir/libkbase_plugin_kde.so*
%_libdir/libkbase_queryview.so*
%_libdir/libkbase_reportview.so*
%_libdir/libkbase_script_py.so*
%if_enabled kjs
%_libdir/libkbase_script_kjs.so*
%endif
%_libdir/libkbase_scriptall.so*
%_libdir/libkbase_el32.so*
#%_libdir/libkbase_script_pysys.so
%_libdir/libkbase_tableview.so*
# data
%_datadir/apps/rekall/services/kdeparts.lst
#%_datadir/apps/rekall/services/rekall_*.desktop
%_datadir/apps/rekall/stock
%_datadir/apps/rekall/wizards
%_desktopdir/rekall.desktop
%python_sitelibdir/rkdcop.so
#%_menudir/*

%files common -f %name.lang
# libraries
%_libdir/libkbase_common.so*
%_libdir/libkbase_driver_csv.so*
%if_enabled kjs
%_libdir/libkbase_driver_test.so*
%_datadir/apps/rekall/test
%endif
#%_libdir/libel_compile.so
#%_libdir/libel_interp.so
%if_enabled kde
%_libdir/libkbase_kde.so*
%endif
#%_libdir/libkbase_tkwidgets.so
# data
%dir %_datadir/apps/rekall
%_datadir/apps/rekall/gui
%_datadir/apps/rekall/manual
%_datadir/apps/rekall/highlights
#%_datadir/apps/rekall/LICENSE
%_datadir/apps/rekall/dict
#%_datadir/apps/rekall/help
%_docdir//kde/HTML/en/rekall/
#%_datadir/apps/rekall/highlight
%_datadir/apps/rekall/icons
%_datadir/apps/rekall/keymaps
%_datadir/apps/rekall/pics
%_datadir/apps/rekall/rekall.png
%_datadir/apps/rekall/rekall_lite.png
#%_datadir/apps/rekall/rekallui.*
%_datadir/apps/rekall/script
%dir %_datadir/apps/rekall/services
%_datadir/apps/rekall/services/rekall_dummy.desktop
%_datadir/apps/rekall/services/rekall_component.desktop
%_datadir/apps/rekall/services/rekall_copier.desktop
%_datadir/apps/rekall/services/rekall_editor.desktop
%_datadir/apps/rekall/services/rekall_form.desktop
%_datadir/apps/rekall/services/rekall_macro.desktop
%_datadir/apps/rekall/services/rekall_plugin*.desktop
%_datadir/apps/rekall/services/rekall_query.desktop
%_datadir/apps/rekall/services/rekall_report.desktop
%_datadir/apps/rekall/services/rekall_script_py.desktop
%_datadir/apps/rekall/services/rekall_table.desktop

#TODO: runtime?
#%files runtime
%_bindir/rkdcop
%if_enabled kjs
%_bindir/rkt_*
%_libdir/libkbase_rkt*
%endif
## libraries
%_libdir/libkbase_rkdcop*
#%_libdir/libkbasert_app.so
#%_libdir/librekallrt.so
## modules
#%_libdir/libkbasert_*.so
## data
#%_datadir/apps/rekall/services/rekallrt_*.desktop
#%_datadir/apps/rekallrt
#%_desktopdir/rekallrt.desktop

%files driver-sqlite
%_libdir/libkbase_driver_sqlite3.so*
%_datadir/apps/rekall/services/rekall_driver_sqlite3.desktop

%files driver-odbc
%_libdir/libkbase_driver_odbc.so*
%_datadir/apps/rekall/services/rekall_driver_odbc.desktop

%files driver-mysql
%_libdir/libkbase_driver_mysql.so*
%_datadir/apps/rekall/services/rekall_driver_mysql.desktop

%files driver-pgsql
%_libdir/libkbase_driver_pgsql.so*
%_datadir/apps/rekall/services/rekall_driver_pgsql.desktop

%files driver-xbase
%_libdir/libkbase_driver_xbase.so*
%_libdir/libkbase_support_xbase.so*
%_libdir/libkbase_support_xbsql.so*
%_datadir/apps/rekall/services/rekall_driver_xbase.desktop

%files driver-dbtcp
%_libdir/libkbase_driver_dbtcp.so*
%_libdir/libkbase_support_dbtcp.so*
%_datadir/apps/rekall/services/rekall_driver_dbtcp.desktop

%files driver-mdb
%_libdir/libkbase_driver_mdb.so*
%_datadir/apps/rekall/services/rekall_driver_mdb.desktop

%files devel
#%exclude %_libdir/libkbase_driver*.so
#%_libdir/lib*.so
#%_includedir/rekall

%changelog
* Sun May 25 2008 Vitaly Lipatov <lav@altlinux.ru> 2.4.6-alt2
- update buildreq

* Wed Apr 23 2008 Vitaly Lipatov <lav@altlinux.ru> 2.4.6-alt1
- new version 2.4.6 (with rpmrb script)
- fix build on x86_64
- separate dbtcp, mdb packages, add csv driver support

* Mon Oct 29 2007 Vitaly Lipatov <lav@altlinux.ru> 2.4.5-alt2
- fix build, update buildreq
- build with libpq5.2, package dbtcp driver

* Mon Feb 26 2007 Vitaly Lipatov <lav@altlinux.ru> 2.4.5-alt1
- disable kjs support
- disable tests

* Sat Dec 30 2006 Vitaly Lipatov <lav@altlinux.ru> 2.4.5-alt0.1
- new version 2.4.5 (with rpmrb script)

* Sun May 21 2006 Vitaly Lipatov <lav@altlinux.ru> 2.4.3-alt0.1
- new version 2.4.3
- fix linking

* Mon Mar 20 2006 Vitaly Lipatov <lav@altlinux.ru> 2.4.0-alt0.3
- rebuild with MySQL 5.x
- disable kjs support
- disable --as-needed :(

* Sun Dec 04 2005 Vitaly Lipatov <lav@altlinux.ru> 2.4.0-alt0.2
- rebuild with postgresql 8.1

* Mon Oct 24 2005 Vitaly Lipatov <lav@altlinux.ru> 2.4.0-alt0.1
- new version

* Sun Oct 09 2005 Vitaly Lipatov <lav@altlinux.ru> 2.3.4-alt0.2pre
- new version
- change rpm & menu group 

* Sat Jun 18 2005 Vitaly Lipatov <lav@altlinux.ru> 2.3.4-alt0.1pre
- first build for ALT Linux Sisyphus
- cvs version from 2005-06-18
